/*
 * Plot - plot time-based data on screen and to file with interactive controls
 * Copyright (C) 2006  Jonas Berlin <xkr47@outerspace.dyndns.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 ****
 * font_dialog - functions related to the font selection dialog
 */

#include <gtk/gtkfontsel.h>

#include "font_dialog.xh"

static void font_response(GtkFontSelectionDialog *dialog, gint response, my_plot_t *plot) {
   if(response == GTK_RESPONSE_OK || response == GTK_RESPONSE_APPLY) {
      if(plot->font) free(plot->font);
      plot->font = g_strdup(gtk_font_selection_dialog_get_font_name(dialog));
      plot->fontsize_at_width = gdk_screen_get_width(gtk_window_get_screen(plot->parent));
      plot_size_or_font_changed(plot);
   }

   if(response != GTK_RESPONSE_APPLY) {
      gtk_widget_destroy(GTK_WIDGET(dialog));
   }
}

void font_dialog_run(my_plot_t *plot) {
   GtkFontSelectionDialog *dialog = GTK_FONT_SELECTION_DIALOG(gtk_font_selection_dialog_new("Select font"));
   gtk_widget_show(dialog->apply_button);
   gtk_font_selection_dialog_set_preview_text(dialog, FONT_TEST_STRING);
   gtk_font_selection_dialog_set_font_name(dialog, plot->font);
   /* TODO
   char *font = pango_font_description_to_string(plot->view[0]->pangofont);
   gtk_font_selection_dialog_set_font_name(dialog, font);
   g_free(font);
   */
   g_signal_connect(dialog, "response", G_CALLBACK(font_response), plot);
   gtk_widget_show(GTK_WIDGET(dialog));
}
